# DOMTreeWalker Class Reference

`DOMTreeWalker` objects are used to navigate a document tree or subtree using the view of the document defined by their `whatToShow` flags and filter (if any). More...

List of all members.

## Public Member Functions

Destructor
virtual | ~DOMTreeWalker ()
| Destructor.
Functions introduced in DOM Level 2
virtual DOMNode * | getRoot ()=0
| The `root` node of the `DOMTreeWalker`, as specified when it was created.
virtual DOMNodeFilter::ShowType | getWhatToShow ()=0
| This attribute determines which node types are presented via the `DOMTreeWalker`.
virtual DOMNodeFilter * | getFilter ()=0
| Return The filter used to screen nodes.
virtual bool | getExpandEntityReferences ()=0
| The value of this flag determines whether the children of entity reference nodes are visible to the `DOMTreeWalker`.
virtual DOMNode * | getCurrentNode ()=0
| Return the node at which the DOMTreeWalker is currently positioned.
virtual DOMNode * | parentNode ()=0
| Moves to and returns the closest visible ancestor node of the current node.
virtual DOMNode * | firstChild ()=0
| Moves the `DOMTreeWalker` to the first visible child of the current node, and returns the new node.
virtual DOMNode * | lastChild ()=0
| Moves the `DOMTreeWalker` to the last visible child of the current node, and returns the new node.
virtual DOMNode * | previousSibling ()=0
| Moves the `DOMTreeWalker` to the previous sibling of the current node, and returns the new node.
virtual DOMNode * | nextSibling ()=0
| Moves the `DOMTreeWalker` to the next sibling of the current node, and returns the new node.
virtual DOMNode * | previousNode ()=0
| Moves the `DOMTreeWalker` to the previous visible node in document order relative to the current node, and returns the new node.
virtual DOMNode * | nextNode ()=0
| Moves the `DOMTreeWalker` to the next visible node in document order relative to the current node, and returns the new node.
virtual void | setCurrentNode (DOMNode *currentNode)=0
| The node at which the `DOMTreeWalker` is currently positioned.
Non-standard Extension
virtual void | release ()=0
| Called to indicate that this TreeWalker is no longer in use and that the implementation may relinquish any resources associated with it.

## Protected Member Functions

Hidden constructors
| DOMTreeWalker ()
| DOMTreeWalker (const DOMTreeWalker &)

## Detailed Description

`DOMTreeWalker` objects are used to navigate a document tree or subtree using the view of the document defined by their `whatToShow` flags and filter (if any).

Any function which performs navigation using a `DOMTreeWalker` will automatically support any view defined by a `DOMTreeWalker`.

Omitting nodes from the logical view of a subtree can result in a structure that is substantially different from the same subtree in the complete, unfiltered document. Nodes that are siblings in the `DOMTreeWalker` view may be children of different, widely separated nodes in the original view. For instance, consider a `DOMNodeFilter` that skips all nodes except for DOMText nodes and the root node of a document. In the logical view that results, all text nodes will be siblings and appear as direct children of the root node, no matter how deeply nested the structure of the original document.

See also the Document Object Model (DOM) Level 2 Traversal and Range Specification.

Since:
  DOM Level 2

## Constructor & Destructor Documentation

DOMTreeWalker::DOMTreeWalker | ( |  | ) | `[protected]`

DOMTreeWalker::DOMTreeWalker | ( | const DOMTreeWalker & |  | ) | `[protected]`

virtual DOMTreeWalker::~DOMTreeWalker | ( |  | ) | `[virtual]`

Destructor.

## Member Function Documentation

virtual DOMNode* DOMTreeWalker::getRoot | ( |  | ) | `[pure virtual]`

The `root` node of the `DOMTreeWalker`, as specified when it was created.

Since:
  DOM Level 2

virtual DOMNodeFilter::ShowType DOMTreeWalker::getWhatToShow | ( |  | ) | `[pure virtual]`

This attribute determines which node types are presented via the `DOMTreeWalker`.

The available set of constants is defined in the `DOMNodeFilter` interface. Nodes not accepted by `whatToShow` will be skipped, but their children may still be considered. Note that this skip takes precedence over the filter, if any.

Since:
  DOM Level 2

virtual DOMNodeFilter* DOMTreeWalker::getFilter | ( |  | ) | `[pure virtual]`

Return The filter used to screen nodes.

Since:
  DOM Level 2

virtual bool DOMTreeWalker::getExpandEntityReferences | ( |  | ) | `[pure virtual]`

The value of this flag determines whether the children of entity reference nodes are visible to the `DOMTreeWalker`.

If false, these children and their descendants will be rejected. Note that this rejection takes precedence over `whatToShow` and the filter, if any.
To produce a view of the document that has entity references expanded and does not expose the entity reference node itself, use the `whatToShow` flags to hide the entity reference node and set `expandEntityReferences` to true when creating the `DOMTreeWalker`. To produce a view of the document that has entity reference nodes but no entity expansion, use the `whatToShow` flags to show the entity reference node and set `expandEntityReferences` to false.

Since:
  DOM Level 2

virtual DOMNode* DOMTreeWalker::getCurrentNode | ( |  | ) | `[pure virtual]`

Return the node at which the DOMTreeWalker is currently positioned.

Since:
  DOM Level 2

virtual DOMNode* DOMTreeWalker::parentNode | ( |  | ) | `[pure virtual]`

Moves to and returns the closest visible ancestor node of the current node.

If the search for `parentNode` attempts to step upward from the `DOMTreeWalker`'s `root` node, or if it fails to find a visible ancestor node, this method retains the current position and returns `null`.

Returns:
  The new parent node, or `null` if the current node has no parent in the `DOMTreeWalker`'s logical view.

Since:
  DOM Level 2

virtual DOMNode* DOMTreeWalker::firstChild | ( |  | ) | `[pure virtual]`

Moves the `DOMTreeWalker` to the first visible child of the current node, and returns the new node.

If the current node has no visible children, returns `null`, and retains the current node.

Returns:
  The new node, or `null` if the current node has no visible children in the `DOMTreeWalker`'s logical view.

Since:
  DOM Level 2

virtual DOMNode* DOMTreeWalker::lastChild | ( |  | ) | `[pure virtual]`

Moves the `DOMTreeWalker` to the last visible child of the current node, and returns the new node.

If the current node has no visible children, returns `null`, and retains the current node.

Returns:
  The new node, or `null` if the current node has no children in the `DOMTreeWalker`'s logical view.

Since:
  DOM Level 2

virtual DOMNode* DOMTreeWalker::previousSibling | ( |  | ) | `[pure virtual]`

Moves the `DOMTreeWalker` to the previous sibling of the current node, and returns the new node.

If the current node has no visible previous sibling, returns `null`, and retains the current node.

Returns:
  The new node, or `null` if the current node has no previous sibling. in the `DOMTreeWalker`'s logical view.

Since:
  DOM Level 2

virtual DOMNode* DOMTreeWalker::nextSibling | ( |  | ) | `[pure virtual]`

Moves the `DOMTreeWalker` to the next sibling of the current node, and returns the new node.

If the current node has no visible next sibling, returns `null`, and retains the current node.

Returns:
  The new node, or `null` if the current node has no next sibling. in the `DOMTreeWalker`'s logical view.

Since:
  DOM Level 2

virtual DOMNode* DOMTreeWalker::previousNode | ( |  | ) | `[pure virtual]`

Moves the `DOMTreeWalker` to the previous visible node in document order relative to the current node, and returns the new node.

If the current node has no previous node, or if the search for `previousNode` attempts to step upward from the `DOMTreeWalker`'s `root` node, returns `null`, and retains the current node.

Returns:
  The new node, or `null` if the current node has no previous node in the `DOMTreeWalker`'s logical view.

Since:
  DOM Level 2

virtual DOMNode* DOMTreeWalker::nextNode | ( |  | ) | `[pure virtual]`

Moves the `DOMTreeWalker` to the next visible node in document order relative to the current node, and returns the new node.

If the current node has no next node, or if the search for nextNode attempts to step upward from the `DOMTreeWalker`'s `root` node, returns `null`, and retains the current node.

Returns:
  The new node, or `null` if the current node has no next node in the `DOMTreeWalker`'s logical view.

Since:
  DOM Level 2

virtual void DOMTreeWalker::setCurrentNode | ( | DOMNode * | currentNode | ) | `[pure virtual]`

The node at which the `DOMTreeWalker` is currently positioned.

Alterations to the DOM tree may cause the current node to no longer be accepted by the `DOMTreeWalker`'s associated filter. `currentNode` may also be explicitly set to any node, whether or not it is within the subtree specified by the `root` node or would be accepted by the filter and `whatToShow` flags. Further traversal occurs relative to `currentNode` even if it is not part of the current view, by applying the filters in the requested direction; if no traversal is possible, `currentNode` is not changed.

Exceptions:

  | DOMException | NOT_SUPPORTED_ERR: Raised if an attempt is made to set `currentNode` to `null`.

Since:
  DOM Level 2

virtual void DOMTreeWalker::release | ( |  | ) | `[pure virtual]`

Called to indicate that this TreeWalker is no longer in use and that the implementation may relinquish any resources associated with it.

Access to a released object will lead to unexpected result.

The documentation for this class was generated from the following file:

- DOMTreeWalker.hpp